'*******************************
'Clean HTM files v0.1.1
'Clear garbage from htlm files
'Written by Frederic Hage(c)
'fredledingo@yahoo.com
'*******************************
'-----------------------------------------------------------
Title = "HTM Cleaner"
'--------browse for a folder---------
Set objShell = CreateObject("Shell.Application")
Set objFolder = objShell.BrowseForFolder(0, "Select the folder where the htlm files are located", 0, 36) '---36: "My Computer"
	If objFolder Is Nothing Then
	Path = InputBox("Do you want to paste a path here instead?", Title,, 512, 384)
		If path="" Then
		MsgBox "Action canceled.",,Title 
		wscript.quit 
		End If
	Else
	Path = objFolder.Items.Item.path
	End If
Set objFolder = Nothing
Set fso = CreateObject("Scripting.FileSystemObject")
Set Folder = fso.getfolder(Path)
Set Files = folder.files
'---------------------
Dim f, SrcText, FilePath, FileName, Title, Msg, DirtyHtm, path, Chr62InPre, NewHtm
Title = "HTM Cleaner"
'------Check if Dirty_htm exists, and if not create it--------------
DirtyHtm = path & "\Dirty_Htm" '-----don't add "\" in hcl version
	If Fso.FolderExists(DirtyHtm) Then
	MsgBox "The original files will be saved in the folder:" & VbCrlf & """" & DirtyHtm & """",,Title 
	Else
	Fso.CreateFolder(DirtyHtm)
	MsgBox "Folder:" & VbCrlf & """" & DirtyHtm & """"  & VbCrlf & "was created to save the original files.",,Title 
	End If
'---------ask to add x and email marks-----
	If MsgBox("Add [X] and [email] marks?" _
		& VbCrlf _
		& VbCrlf & "[X] when a link is dead." _
		& VbCrlf & "[email] when a link launch your e-mail application.", vbYesNo, Title) = vbYes Then
	AddMarks = True
	Else
	AddMarks = False
	End if
'------------Ask to confirm for each file-------
	If (MsgBox("Confirm for each file?", vbYesNo, Title) = vbYes) Then
	AskToConfirm = True
	Else
	AskToConfirm = False
	'-----------time estimation-----------
		For Each file in files
		Set f = fso.GetFile(file)
		Set ts = f.OpenAsTextStream(1,0)
		If ts.ReadLine <> "<!--version modified by Fredledingue's html cleaner -->" Then
		fz = f.size
		fsz = fsz + fz + fz*(fz/100000) 
		End If
		ts.Close
		Next
		If Round(fsz/20000,1) > 2.5 Then
			If MsgBox("It will take very aproximately " & Round(fsz/20000,1) & " seconds on a 1Ghz processor." _
					& VbCrlf & "Continue?", 1+64, Title)=2 Then
			MsgBox "Action canceled.",,Title
			wscript.quit
			End if
		End If
	End If
st=Timer
'--------Ouvre le fichier-----
Set fso = CreateObject("Scripting.FileSystemObject")
'-------------Process files-----------------
x=0
For Each file in files
Set f = fso.GetFile(file)
FileName = f.name
FilePath = f.path
stf1 = Timer
GoAhead = False
If fso.GetExtensionName(FilePath)="htm" Or fso.GetExtensionName(FilePath)="html" Then
	'------confirm-----
	If AskToConfirm = True Then
		If (MsgBox("Clean """ & FileName & """ ?", vbYesNo, Title) = vbYes) Then
		GoAhead = True
		End If
	Else
	GoAhead = True
	End If
	'---------process the file line by line-------------
	If GoAhead = True Then
	'----------SART OF: same as hcl version----
	SrcText = ""
	Chr62InPre = False
	Set ts = f.OpenAsTextStream(1, 0)
	t = ts.ReadAll
	ts.Close
		If InStr(t,"<!--version modified by Fredledingue's html cleaner -->")>0 Then
		Msg = Msg & """" & FileName & """: " & VbTab & "Already clean." & VbCrlf
		ElseIf InStr(t,"<PRE")>0 Or InStr(t,"<pre")>0 Then
		t=Replace(t,Chr(10),VbCrlf)
		L = Split(t, VbCrlf)
		x = UBound(L)
			For i=0 To x
			SrcText = SrcText & L(i)
				If InStr(LCase(L(i)),"<pre")>0 Then
				SrcText = SrcText & "[-NewLineInPre-]"
					Do Until InStr(LCase(L(i)),"</pre>")>0 Or i=x-1
					i=i+1
						If InStr(L(i),">")>0 And Right(L(i),1) <> ">" Then			
						SrcText = SrcText & Replace(L(i),">",">[-Chr62InPre-]") & "[-NewLineInPre-]"
						Chr62InPre = True
						Else
						SrcText = SrcText & L(i) & "[-NewLineInPre-]"
						End If
					Loop
				End If
			Next
		SrcText = Replace(SrcText,VbCrlf, "")
		SrcText = Replace(SrcText, "[-NewLineInPre-]" ,VbCrlf)
		
		Call CleanIt
		Else
		SrcText = t
		SrcText = Replace(Replace(SrcText,VbCrlf, ""),Chr(10),"")
		Call CleanIt
		End If
	'----------END OF: same as hcl version----
	End if       '------refers to "If GoAhead = True"
End If      '-----refers to "If fso.GetExtensionName(FilePath)="htm"..."
Next
MsgBox "Result: Process duration: " & Round(Timer - st,1) & " (est: " & Round(fsz/30000,1) & ")" & VbCrlf & VbCrlf & Msg,, Title
'-----------------------End of main Script----------------------------

'------------------------Subscript----same as hcl version-------------------------
Sub CleanIt
	NewHtm = "<!--version modified by Fredledingue's html cleaner -->" & VbCrlf
	LineCount = 0
	DelLineCount = 0
	DelImgCount = 0
	IsScript = False
	SrcText = Replace(SrcText,">", ">" & VbCrlf)
	SrcText = Replace(SrcText,"= """, "=""")
	SrcText = Replace(SrcText," =""", "=""")
	L = Split(SrcText, vbCrlf, -1, 1)
	'--------count lines------
	LineCount = UBound(L)
	'---------remove unwanted code-------
		For i=0 To LineCount
			'-------remove script and geocities code-----
			If L(i)=Chr(10) Or InStr(LCase(L(i)),"<noscript")>0 Or InStr(LCase(L(i)),"</noscript")>0 Then
			DelLineCount = DelLineCount +1
			ElseIf IsScript = True Then	
			DelLineCount = DelLineCount +1
				If InStr(L(i),"<!-- preceding code added by server. PLEASE REMOVE -->")>0 Then
				IsScript = False
				End If
				If InStr(LCase(L(i)),"</script")>0 Then
				IsScript = False
				End If
			ElseIf InStr(LCase(L(i)),"<script")>0 Then
			DelLineCount = DelLineCount +1
				If InStr(LCase(L(i)),"</script")=0 Then
				IsScript = True
				End If
			ElseIf InStr(LCase(L(i)),"href='javascript")>0 Then
			DelLineCount = DelLineCount +1
			ElseIf InStr(L(i),"<!-- following code added by server. PLEASE REMOVE -->")>0  Then
			DelLineCount = DelLineCount +1
			IsScript = True
			ElseIf InStr(L(i),"<!-- text above generated by server. PLEASE REMOVE -->")>0 Then
			DelLineCount = DelLineCount +1
			NewHtm = "<!--version modified by Fredledingue's html cleaner -->" & VbCrlf
			ElseIf InStr(L(i),"<!-- text below generated by server. PLEASE REMOVE -->")>0 Then
			DelLineCount = DelLineCount +1
			'--------remove missing images------
			ElseIf InStr(LCase(L(i)),"src=""")>0 Then
			u=InStr(LCase(L(i)),"src=""")+5
			v=Mid(L(i),u)
			w=InStr(v,"""")
				If w=0 Then
				w=InStr(v," ")
				End If
				If w>1 Then
				img = Replace(Left(v,w-1) ,"%20", " ")
				End If
				If Fso.FileExists(path & "/" & img) Or Fso.FileExists(img) Then
				AddLine(L(i))
				Else
				DelLineCount = DelLineCount +1
				DelImgCount = DelImgCount +1
				End If
			img = ""
			'-----
			ElseIf InStr(LCase(L(i)),"src=")>0 Then
			u=InStr(LCase(L(i)),"src=")+4
			v=Mid(L(i),u)
			w=InStr(v,".")
				If w>1 Then
				img = Replace(Left(v,w+3) ,"%20", " ")
				End If
				If Fso.FileExists(path & "/" & img) Or Fso.FileExists(img) Then
				AddLine(L(i))
				Else
				DelLineCount = DelLineCount +1
				DelImgCount = DelImgCount +1
				End If
			img = ""
			ElseIf InStr(LCase(L(i)),"background-image: url(" )>0 Then
			u=InStr(LCase(L(i)), "background-image: url(" ) +22
			v=Mid(L(i),u)
			w=InStr(v,")")
				If w>1 Then
				img = Replace(Left(v,w-1) ,"%20", " ")
				End If
				If Fso.FileExists(path & "/" & img) Or Fso.FileExists(img) Then
				AddLine(L(i))
				Else
				DelLineCount = DelLineCount +1
				DelImgCount = DelImgCount +1
				AddLine("</STYLE>")
				End If
			img = ""
			ElseIf  InStr(LCase(L(i)),"background=""http" )>0 Then
			u=InStr(LCase(L(i)), "background=""http" )
			v=Mid(L(i), u+16)
			w=Mid(v, InStr(v,"""")) 
			NewHtm = NewHtm & VbCrlf & Left(L(i),u-1) & w
			ElseIf InStr(L(i)," rel=")>0 Or InStr(L(i)," REL=")>0 Then
			DelLineCount = DelLineCount +1
			'-------reajust flags and links-----
			ElseIf InStr(LCase(L(i)),"href=""")>0 Then
				If InStr(L(i),"href=""#")>0 Then
				AddLine(L(i))
				ElseIf InStr(L(i),"#")>0 Then
				u=InStr(LCase(L(i)),"href=""")+6
				v=Mid(L(i),u)
				w=InStr(v,"#")
				img = Replace(Left(v,w-1), "%20", " ")
					If InStr(LCase(img),"http://")>0 Or InStr(LCase(img),"ftp://")>0 Then
					img = Mid(img, InStrRev(img,"/")+1)
					End If
					'-------------
					If LCase(img) = LCase(FilePath) Or LCase(img) = LCase(FileName) Then
					AddLine( Left(L(i), u ) & Mid(L(i), InStr(L(i),"#")) )
					ElseIf Fso.FileExists(path & "/" & img) Or Fso.FileExists(img) Then 'Or Replace(img, " ","")="" Then
					AddLine(L(i))
					Else
						If InStr(SrcText, "name=""" & Mid(v, w+1, InStr(v,"""")-w-1) ) >0 Or InStr(SrcText, "NAME=""" & Mid(v, w+1, InStr(v,"""")-w-1) ) >0 Then
						AddLine( Left(L(i), u-1 ) & Mid(L(i), InStr(L(i),"#")) )
						ElseIf AddMarks = True And InStr(LCase(L(i)),"http://")=0 And InStr(LCase(L(i)),"ftp://")=0 Then
						AddLine( L(i) & "[X]" )
						Else
						AddLine(L(i))
						End If
					End If
				img = ""				
				ElseIf InStr(LCase(L(i)),"http://")>0 Or InStr(LCase(L(i)),"ftp://")>0 Then
				AddLine(L(i))
				ElseIf InStr(L(i),"@")>0 Then
					If AddMarks = True Then
					AddLine( L(i) & "[email]" )
					Else
					AddLine(L(i))
					End If
				Else
				u=InStr(LCase(L(i)),"href=""")+6
				v=Mid(L(i),u)
				w=InStr(v,"""")
					If w=0 Then
					w=InStr(v," ")
					End If
					If w>1 Then
					img = Replace(Left(v,w-1) , "%20", " ")
					End If
					If Fso.FileExists(path & "/" & img) Or Fso.FileExists(img) Then
					AddLine(L(i))
					Else
						If AddMarks = True Then
						AddLine( L(i) & "[X]" )
						Else
						AddLine(L(i))
						End If
					End If
				img = ""
				End If
			Else
			'------accpet all other lines------------
			AddLine(L(i))
			End If 
		Next
		If Chr62InPre = True Then
		'MsgBox "[-Chr62InPre-]",,"debug"
		End If
	'----------create message for feedback----------
	Msg = Msg & """" & FileName & """: " & VbTab & DelLineCount & " on " & LineCount & " (" & DelImgCount & " images missing)" & VbCrlf
	'--------Move original file to Dirty_htm-----
		If fso.FileExists(DirtyHtm & "\" & FileName) = False Then
		f.Move DirtyHtm & "\" & FileName
		Else
		f.Move DirtyHtm & "\" & Replace(FileName,".htm","") & Replace(Date,"/","") & Replace(Time,":","") & ".htm"
		Msg = Msg & "(Original version renamed in Dirty_Htm.)" & VbCrlf
		End If
	'--------write to file-----------
	Set objOutputFile = fso.CreateTextFile(FilePath, True)
	objOutputFile.Write NewHtm
	objOutputFile.Close
End Sub
'----------function add line--------
Function AddLine(MyLine)
	If InStr(MyLine, "[-Chr62InPre-]") = 0 Then
	NewHtm = NewHtm & VbCrlf & MyLine
	Else
	NewHtm = NewHtm & Replace(MyLine, "[-Chr62InPre-]", "")
	End If
End Function


